
#include <stdio.h>
#include <stdlib.h>
#include <pcap.h>
#include <pcap-bpf.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <string.h>
#include <stdint.h>
#include <netinet/ip.h>
#include <linux/udp.h>
#include <linux/tcp.h>
#include <inttypes.h>


#define GETUS(t) ((t.tv_sec*1000000)+(t.tv_usec))
uint32_t ipcl, ipsvr;
char filename[200];
uint16_t puertocliente, puertoservidor;
uint32_t *bytes,*bytes1;
uint32_t *packets, *packets1;
uint8_t ihlaux=0;


int leer_fichero (void){
	int i=0, j=0;
	FILE *fichero;
	char ipcliente[100]={0}, ipservidor[100]={0};
	char auxipc[100]={0}, auxipsrv[100]={0};

	fichero= fopen ("tcptracker.cfg","r");
 	if (fichero == NULL)
    	{
        	printf("Error abriendo tcptracker.cfg");
        	return -1;
    	}
	fscanf (fichero, "%s\n%s\n%hd\n%hd\n%s\n" ,ipcliente,ipservidor,&puertocliente,&puertoservidor,filename);
	printf("\n%s\n",ipservidor);
	
	while(ipcliente[i]!='\0') {
		if(ipcliente[i]=='.')
			i++;

		auxipc[j]=ipcliente[i];
		
		i++;
		j++;	
	}
i=0;
j=0;
	while(ipservidor[i]!='\0') {
		if(ipservidor[i]=='.')
			i++;

		auxipsrv[j]=ipservidor[i];

		i++;
		j++;	
	}

	
	ipcl= (uint32_t*)auxipc;
	ipsvr= (uint32_t*)auxipsrv;
printf("\n%s\n",auxipsrv);
printf("\n%u\n", ipsvr);
	return 0;
} 
int main(){
	int flag=0;
	char errbuf[PCAP_ERRBUF_SIZE];
	struct pcap_pkthdr header;
	uint64_t primero, ultimo;
	pcap_t*handle;
	const u_char* packet;
	uint8_t sizeRead=0;
	uint16_t portorig;
	uint16_t portdest;	
	uint8_t ihlaux=0;
	uint8_t ihl=0,auxlong=0;
	uint16_t i_ethertype=0;
	uint8_t protocolo=0;
	uint32_t ip_src,ip_dest;
	uint64_t duration;

	leer_fichero();
	handle=pcap_open_offline(filename,errbuf);
	if(handle==NULL)
	{
		fprintf(stderr,"No se puede abrir traza.pcap %s\n",errbuf);
		return -1;
	}
	while ((packet = pcap_next(handle,&header))!=NULL)
	{	
		sizeRead=12;
		
		memcpy(&i_ethertype,packet+ sizeRead,sizeof(uint16_t));

		i_ethertype=ntohs(i_ethertype);
	 	sizeRead+=sizeof(uint16_t);
		
		if(i_ethertype!=0x0800)
			continue;

		auxlong=0;
		auxlong=sizeRead;
		memcpy(&ihlaux,sizeRead+packet,sizeof(uint8_t));/*IHL*/
		sizeRead+=sizeof(uint8_t);
		
		ihl=ihlaux&(0x0F); /*mascara para sacar el ihl*/ 
		ihl=ihl*4;				
		sizeRead+=8*sizeof(uint8_t);
		
		memcpy(&protocolo,sizeRead+packet,sizeof(uint8_t));/*PROTOCOLO*/
		sizeRead+=sizeof(uint8_t);
		
		if (protocolo!=6)
			continue;



		sizeRead+=sizeof(uint16_t); /*leemos la ip origen*/
		memcpy(&ip_src,sizeRead+packet,sizeof(uint32_t));
		sizeRead+=sizeof(uint32_t);
		ip_src=ntohl(ip_src); 
		if(ip_src!=ipsvr&&ip_src!=ipcl) 
			continue;
	
		memcpy(&ip_dest,sizeRead+packet,sizeof(uint32_t)); /*leemos la ip destino*/
		sizeRead+=sizeof(uint32_t);
		ip_dest=ntohl(ip_dest);	
		sizeRead=auxlong+ihl;		
		if(ip_dest!=ipsvr&&ip_dest!=ipcl) 
			continue;

		memcpy(&ip_dest,sizeRead+packet,sizeof(uint32_t)); /*leemos la ip destino*/
		sizeRead+=sizeof(uint32_t);
		ip_dest=ntohl(ip_dest);
		sizeRead=auxlong+ihl;			
		

		memcpy(&portorig,sizeRead+packet,sizeof(uint16_t));
		sizeRead+=sizeof(uint16_t);
		portorig=ntohs(portorig); /*lectura del puerto origen*/


		if(portorig!=puertoservidor&&portorig!=puertocliente) 
			continue;

		memcpy(&portdest,sizeRead+packet,sizeof(uint16_t)); /*lectura del puerto destino*/
		sizeRead+=sizeof(uint16_t);
		portdest=ntohs(portdest);
		if(portdest!=puertoservidor&&portdest!=puertocliente) 
			continue;

		if(ip_src==ipsvr&&ip_dest!=ipcl){
			(*packets)++;
			(*bytes)+=header.len;	    			  				   
		}
		if(ip_src==ipcl&&ip_dest!=ipsvr){
			(*packets1)++;
			(*bytes1)+=header.len;			 			  				   
		}
		if(flag==0){
			primero=GETUS(header.ts);
			flag=1;
			}	



		};


     
    
	ultimo=GETUS(header.ts);
	duration=ultimo-primero;
	printf("Paquetes Totales:%"PRIu32"\n",packets1);
		printf("Bytes Totales:%"PRIu32"\n",bytes1);
		printf("Duracion: %"PRIu64"\n",duration);
     	pcap_close(handle);   
	
	return 0;
}
	



